/*
 * amigakey.h
 * Amiga specific keyboard routines for Thrust.
 * Written by Frank Wille, frank@phoenix.owl.de
 *
 */

#ifndef AMIGAKEY_H
#define AMIGAKEY_H

#define SCANCODE_ESCAPE                 0x45

#define SCANCODE_1                      0x01
#define SCANCODE_2                      0x02
#define SCANCODE_3                      0x03
#define SCANCODE_4                      0x04
#define SCANCODE_5                      0x05
#define SCANCODE_6                      0x06
#define SCANCODE_7                      0x07
#define SCANCODE_8                      0x08
#define SCANCODE_9                      0x09
#define SCANCODE_0                      0x0a

#define SCANCODE_MINUS                  0x0b
#define SCANCODE_EQUAL                  0x0c

#define SCANCODE_BACKSPACE              0x41
#define SCANCODE_TAB                    0x42

#define SCANCODE_Q                      0x10
#define SCANCODE_W                      0x11
#define SCANCODE_E                      0x12
#define SCANCODE_R                      0x13
#define SCANCODE_T                      0x14
#define SCANCODE_Y                      0x15
#define SCANCODE_U                      0x16
#define SCANCODE_I                      0x17
#define SCANCODE_O                      0x18
#define SCANCODE_P                      0x19
#define SCANCODE_BRACKET_LEFT           0x1a
#define SCANCODE_BRACKET_RIGHT          0x1b

#define SCANCODE_ENTER                  0x44

#define SCANCODE_A                      0x20
#define SCANCODE_S                      0x21
#define SCANCODE_D                      0x22
#define SCANCODE_F                      0x23
#define SCANCODE_G                      0x24
#define SCANCODE_H                      0x25
#define SCANCODE_J                      0x26
#define SCANCODE_K                      0x27
#define SCANCODE_L                      0x28
#define SCANCODE_SEMICOLON              0x29
#define SCANCODE_APOSTROPHE             0x2a
#define SCANCODE_GRAVE                  0x00

#define SCANCODE_LEFTSHIFT              0x60
#define SCANCODE_BACKSLASH              0x0d

#define SCANCODE_Z                      0x31
#define SCANCODE_X                      0x32
#define SCANCODE_C                      0x33
#define SCANCODE_V                      0x34
#define SCANCODE_B                      0x35
#define SCANCODE_N                      0x36
#define SCANCODE_M                      0x37
#define SCANCODE_COMMA                  0x38
#define SCANCODE_PERIOD                 0x39
#define SCANCODE_SLASH                  0x3a

#define SCANCODE_RIGHTSHIFT             0x61
#define SCANCODE_KEYPADMULTIPLY         0x5d

#define SCANCODE_LEFTALT                0x64
#define SCANCODE_SPACE                  0x40
#define SCANCODE_CAPSLOCK               0x62

#define SCANCODE_F1                     0x50
#define SCANCODE_F2                     0x51
#define SCANCODE_F3                     0x52
#define SCANCODE_F4                     0x53
#define SCANCODE_F5                     0x54
#define SCANCODE_F6                     0x55
#define SCANCODE_F7                     0x56
#define SCANCODE_F8                     0x57
#define SCANCODE_F9                     0x58
#define SCANCODE_F10                    0x59

#define SCANCODE_NUMLOCK                0x5a
#define SCANCODE_SCROLLLOCK             0x5b

#define SCANCODE_KEYPAD7                0x3d
#define SCANCODE_KEYPAD8                0x3e
#define SCANCODE_KEYPAD9                0x3f
#define SCANCODE_KEYPADMINUS            0x4a
#define SCANCODE_KEYPAD4                0x2d
#define SCANCODE_KEYPAD5                0x2e
#define SCANCODE_KEYPAD6                0x2f
#define SCANCODE_KEYPADPLUS             0x5e
#define SCANCODE_KEYPAD1                0x1d
#define SCANCODE_KEYPAD2                0x1e
#define SCANCODE_KEYPAD3                0x1f
#define SCANCODE_KEYPAD0                0x0f
#define SCANCODE_KEYPADPERIOD           0x3c

#define SCANCODE_LESS                   0x30

#define SCANCODE_KEYPADENTER            0x43
#define SCANCODE_CONTROL                0x63
#define SCANCODE_KEYPADDIVIDE           0x5c
#define SCANCODE_PRINTSCREEN            0x5d
#define SCANCODE_RIGHTALT               0x65
#define SCANCODE_DEL                    0x46
#define SCANCODE_HELP                   0x5f
#define SCANCODE_AMIGALEFT              0x66
#define SCANCODE_AMIGARIGHT             0x67

#define SCANCODE_PAGEUP                 0x3f
#define SCANCODE_END                    0x1d
#define SCANCODE_PAGEDOWN               0x1f
#define SCANCODE_INSERT                 0x0f
#define SCANCODE_REMOVE                 0x3c

#define SCANCODE_CURSORUP               0x4c
#define SCANCODE_CURSORDOWN             0x4d
#define SCANCODE_CURSORRIGHT            0x4e
#define SCANCODE_CURSORLEFT             0x4f


#endif /* AMIGAKEY_H */
